#!/bin/bash
DEF_CONF=/etc/default/asterniclog
PHP_CONF=/var/www/stats/config.php

## Get db information configured in config.php
PHP_DBHOST=`grep DBHOST $PHP_CONF | awk -F"'" '{print $2}'`
PHP_DBUSER=`grep DBUSER $PHP_CONF | awk -F"'" '{print $2}'`
PHP_DBPASS=`grep DBPASS $PHP_CONF | awk -F"'" '{print $2}'`
PHP_DBNAME=`grep DBNAME $PHP_CONF | awk -F"'" '{print $2}'`

## Get line numbers for db related info in config.php for further replaces
PHP_DBHOST_LINE=`grep -nr DBHOST $PHP_CONF | awk -F":" '{print $1}'`
PHP_DBUSER_LINE=`grep -nr DBUSER $PHP_CONF | awk -F":" '{print $1}'`
PHP_DBPASS_LINE=`grep -nr DBPASS $PHP_CONF | awk -F":" '{print $1}'`
PHP_DBNAME_LINE=`grep -nr DBNAME $PHP_CONF | awk -F":" '{print $1}'`

## Get AMI interface information from callweaver config files
AMI_PORT=`crudini --get /etc/callweaver/manager.conf general port`
AMI_HOST=`crudini --get /etc/callweaver/manager.conf general bindaddr`
AMI_SECRET=`crudini --get /etc/callweaver/manager.conf root secret`
AMI_CNT_STR=`echo $AMI_HOST:$AMI_PORT`

## Get AMI interface information from config.php and it's line numbers
PHP_AMI_HOST=`grep MANAGER_HOST $PHP_CONF | awk -F"\"" '{print $2}'`
PHP_AMI_USER=`grep MANAGER_USER $PHP_CONF | awk -F"\"" '{print $2}'`
PHP_AMI_SECRET=`grep MANAGER_SECRET $PHP_CONF | awk -F"\"" '{print $2}'`
PHP_AMI_HOST_LINE=`grep -nr MANAGER_HOST $PHP_CONF | awk -F":" '{print $1}'`
PHP_AMI_USER_LINE=`grep -nr MANAGER_USER $PHP_CONF | awk -F":" '{print $1}'`
PHP_AMI_SECRET_LINE=`grep -nr MANAGER_SECRET $PHP_CONF | awk -F":" '{print $1}'`

## Get db information from /etc/default/asterniclog, assuming it's single point for configuration
DEF_DBHOST=$(awk -F"-h " '{print $2}' $DEF_CONF | sed '/^$/d' | awk '{print $1}')
DEF_DBUSER=$(awk -F"-u " '{print $2}' $DEF_CONF | sed '/^$/d' | awk '{print $1}')
DEF_DBPASS=$(awk -F"-p " '{print $2}' $DEF_CONF | sed '/^$/d' | awk '{print $1}')
DEF_DBNAME=$(awk -F"-d " '{print $2}' $DEF_CONF | sed '/^$/d' | awk '{print $1}')

## Initialize proper database values form /etc/default/asterniclog configration
if [ $PHP_DBHOST != $DEF_DBHOST ]; then
	sed -i "${PHP_DBHOST_LINE}s#${PHP_DBHOST}#${DEF_DBHOST}#" $PHP_CONF
fi
if [ $PHP_DBUSER != $DEF_DBUSER ]; then
        sed -i "${PHP_DBUSER_LINE}s#${PHP_DBUSER}#${DEF_DBUSER}#" $PHP_CONF
fi
if [ $PHP_DBPASS != $DEF_DBPASS ]; then
        sed -i "${PHP_DBPASS_LINE}s#${PHP_DBPASS}#${DEF_DBPASS}#" $PHP_CONF
fi
if [ $PHP_DBNAME != $DEF_DBNAME ]; then
        sed -i "${PHP_DBNAME_LINE}s#${PHP_DBNAME}#${DEF_DBNAME}#" $PHP_CONF
fi

## Initialize proper AMI interface connection links
if [ $PHP_AMI_HOST != $AMI_CNT_STR ]; then
	sed -i "${PHP_AMI_HOST_LINE}s#${PHP_AMI_HOST}#${AMI_CNT_STR}#" $PHP_CONF
fi
if [ $PHP_AMI_USER != "root" ]; then
	sed -i "${PHP_AMI_USER_LINE}s#${PHP_AMI_USER}#root#" $PHP_CONF
fi
if [ $PHP_AMI_SECRET != $AMI_SECRET ]; then
	sed -i "${PHP_AMI_SECRET_LINE}s#${PHP_AMI_SECRET}#${AMI_SECRET}#" $PHP_CONF
fi

## Enable queue_log in callweaver config files
CW_QUEUE_STATUS=`crudini --get /etc/callweaver/logger.conf general queue_log`
[ $CW_QUEUE_STATUS != "on" ] && crudini --set /etc/callweaver/logger.conf general queue_log on

exit 0